From 86e6a121f102acf345992e97222a59e2796bf3d6 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 13 2017 13:11:35 +0000
Subject: [PATCH 40/51] load and process the file in linter methods


Loads and processes the file data in three steps:

1. Read the file and verify its encoding is UTF-8
2. Attempt to parse as YAML.
3. Verify it conforms to the basic ModuleMD YAML structure.

All further linting will depend on these, so we can bail out early.

---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index 0b64094..b2fa084 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -167,16 +167,7 @@ class ModuleMDLinter(object):
                 "specify exactly one of modulemd_path or modulemd_str")
 
         self.modulemd_path = modulemd_path
-
-        if not modulemd_str:
-            with open(modulemd_path, "r") as mmdfile:
-                self.modulemd_str = mmdfile.read()
-        else:
-            self.modulemd_str = modulemd_str
-
-        # We intentionally don't use the modulemd module for linting.
-        self.yaml_doc = yaml.safe_load(self.modulemd_str)
-        self.mmd = self.yaml_doc['data']
+        self.modulemd_str = modulemd_str
 
     def lint(self, min_level=None):
         # ensure that min_level describes a valid level
@@ -306,6 +297,51 @@ class ModuleMDLinter(object):
     # lint checks below
 
     @error
+    @guidelines_link("http://yaml.org/spec/current.html#id2513364")
+    @detail("This file must be encoded in UTF-8 or UTF-16.")
+    def lint_document_is_unicode(self):
+        """A YAML processor must support the UTF-16 and UTF-8 character
+        encodings."""
+        if not self.modulemd_str:
+            try:
+                with open(self.modulemd_path, "r") as mmdfile:
+                    self.modulemd_str = mmdfile.read()
+            except UnicodeDecodeError:
+                raise LintCheckFailed()
+        else:
+            self.check(isinstance(self.modulemd_str, str))
+
+    @error
+    @guidelines_link()
+    @detail("The document is not a YAML file.")
+    @prerequisite('document_is_unicode')
+    @prerequisite_for('*')
+    def lint_document_is_yaml(self):
+        """Each module is defined by a single YAML file and comprises of a
+        number of key-value pairs describing the module's properties and
+        components it contains."""
+        try:
+            self.yaml_doc = yaml.safe_load(self.modulemd_str)
+        except:
+            raise LintCheckFailed()
+
+    @error
+    @guidelines_link()
+    @detail("The document is not a ModuleMD YAML file.")
+    @prerequisite_for('*')
+    def lint_document_is_modulemd_yaml(self):
+        """Each module is defined by a single YAML file and comprises of a
+        number of key-value pairs describing the module's properties and
+        components it contains."""
+        try:
+            self.check(self.yaml_doc['document'] == 'modulemd')
+            self.check(str(self.yaml_doc['version']) == '1')
+            # We intentionally don't use the modulemd module for linting.
+            self.mmd = self.yaml_doc['data']
+        except:
+            raise LintCheckFailed()
+
+    @error
     @guidelines_link('#Module_summary_and_description')
     def lint_summary_exists(self):
         """Every module MUST include a short summary."""

